#!/usr/bin/perl
#
#use warnings;

use Image::Magick;
use CGI::Pretty(':all');
use File::Glob qw(:globally :nocase);

require('webnailer.conf');

my $version = "0.7";
my $i = 0;
my @pix = glob("*.{JPG,GIF,PNG}");

my $q = new CGI;
my $url = $q->url(-absolute=>'1');

my $width= $q->param('width') || $default_width_for_thumbnail;
my $height= $q->param('height') || $default_height_for_thumbnail;
my $pix_on_line = $q->param('pix') || $default_pix_on_line;
my $offset = $q->param('offset') || 0;
my $spec = $q->param('spec') || $pix_on_page;
my $pix_on_page = $max_pix_on_page;
my $paging = undef;

$httpd_thumbs_dir =~ s/\/$//;
$fs_thumbs_dir =~ s/\/$//;

print header;

if (($q->param('action')) && ($q->param('action') eq 'view') && ($q->param('file') > -1))
{

	my $index = $q->param('file');
	my $file = $pix[$index];
	my $image = new Image::Magick;
	$image->Read($file);
	my ($vheight,$vwidth);
	my ($owidth,$oheight) = $image->Get('width','height');

	if (!(($vheight = $q->param('height')) && ($vwidth = $q->param('width'))))
	{
		($vheight,$vwidth) = ($oheight,$owidth);
	}
	if ($file)
	{
		print "<HTML><HEAD><TITLE>$file</TITLE></HEAD>\n";
		print "<BODY bgcolor = $page_background text=$page_text link=$page_link alink=$page_active_link vlink=$page_visited_link>\n";
		print "<CENTER>\n<TABLE bgcolor=$first_table_background align=$first_table_align>\n";
		print "<TR align=$first_table_align valign=$first_table_valign><TD><A HREF=\"$url?offset=$offset&spec=$spec\">[$file]</A>\n" if ($spec);
		print "<TR align=$first_table_align valign=$first_table_valign><TD><A HREF=\"$url?offset=$offset\">[$file]</A>\n" if (!($spec));
		print "<TABLE width=100% bgcolor=$second_table_backgorund><TR>\n";
		print "<TD align=\"left\" width=50%><A HREF=$url?action=view&spec=$spec&file=".($index-1).">prev</A></TD>\n" if ( $index > 0 ); 
		print "<TD align=\"right\" width=50%><A HREF=$url?action=view&spec=$spec&file=".($index+1).">next</A></TD>\n" if ( $index < $#pix ); 
		print "</TR></TABLE>\n";
		print "<TABLE bgcolor=$second_table_background><TR align=$second_table_align>\n";
		print "<TD align=$second_table_align><IMG SRC=\"$file\" width=$vwidth height=$vheight></TD></TR></TABLE>\n";
		print start_form,
			"Desired resolution:<BR>",
			$q->hidden(-name=>'action',-default=>'view'),
			$q->hidden(-name=>'file',-default=>$file),
			$q->textfield(	-name=>'width',
					-default=>$owidth,
					-override=>1,
					-size=>4,
					-maxlength=>4),
			"x",
			$q->textfield(	-name=>'height',
					-default=>$oheight,
					-override=>1,
					-size=>4,
					-maxlength=>4),
			br(),
			submit('view'),
			end_form;
			
		print "<A HREF=\"http://rousse.pm.org/~georgi/webnailer/\" target=\"_blank\">Generated by webnailer v $version</A>\n";
		print "</TD></TR></TABLE></CENTER></BODY></HTML>\n";
	}
exit;

}
else
{

	print "<HTML><HEAD><TITLE>$title</TITLE></HEAD>\n";
	print "<BODY bgcolor=$page_background link=$page_link alink=$page_active_link vlink=$page_visited_link text=$page_text><TABLE bgcolor=$first_table_background align=$first_table_align>\n";
	print "<TR align=$first_table_align valign=$first_table_valign><TD>\n";
	print "<A HREF=\"..\">$title</A></TD></TR>\n";

	print "<TR align=$first_table_align valign=$first_table_valign><TD>\n";
	print "<TABLE width=100%><TR><TD align=left width=33%>\n";

	my $sum = $pix_on_page - 1;
	if ( $#pix > $sum )
	{
		$paging = 1;
		if ( $offset > 0 )
		{
			$sum = $offset - $pix_on_page;
			print "<A HREF=\"$url?offset=$sum\">prev $pix_on_page</A>\n";
		}
	}
	else
	{
		$pix_on_page = $#pix + 1;
	}

	print "</TD><TD align=middle width=33%>\n";
	if ( $paging == 1 )
	{
		$sum = sprintf("%.0f", $#pix / $pix_on_page);
		for ($i = 0; $i < $sum - 1; $i++)
		{
			if ($offset == ($i*$pix_on_page))
			{
				print ($i+1);
				print "&nbsp\n";
			}
			else
			{
				print "<A HREF=\"$url?offset=". ($i*$pix_on_page) ."\">".($i+1)."</A>&nbsp\n";
			}
		}
		$sum = $i*$pix_on_page;
		if (($offset == $sum) && ($spec == ($#pix-$sum+1)))
		{
			print ($i+1)."&nbsp\n";
		}
		else
		{
			print "<A HREF=\"$url?offset=".$sum."&spec=". ($#pix-$sum+1) ."\">".($i+1)."</A>&nbsp\n";
		}
	}
	$i = 0;

	print "</TD><TD align=right width=33%>\n";
	if ( $paging == 1 )
	{
		
		$sum = $offset + $pix_on_page;
		if ( ($sum) < ($#pix - $pix_on_page + 1)  )
		{
			print "<A HREF=\"$url?offset=$sum\">next $pix_on_page</A>\n";
		}
		elsif ( ($sum) < ($#pix + 1))
		{
			$last = $#pix - $sum + 1;
			print "<A HREF=\"$url?offset=$sum&spec=$last\">last $last</A>\n";

		}
	}

	print "</TD></TR></TABLE>\n";
	print "</TD></TR><TR><TD><TABLE bgcolor=$second_table_background><TR align=$second_table_align>\n";

	if ($spec)
	{
		$sum = $offset + $spec - 1;
	}
	else
	{
		$sum = $offset + $pix_on_page - 1;
	}

	for ($j = $offset; $j <= $sum; $j++)
	{
		my $pic = $pix[$j];
		if ($i == $pix_on_line )
		{
			$i = 0;
			print "</TR>\n<TR align=$second_table_align>\n";
		}
		$i++;

		if (!(-d $fs_thumbs_dir))
		{
			print "<TD align=$second_table_align><A HREF=\"$url?action=view&offset=$offset&spec=$spec&file=$j\"><IMG SRC=\"$pic\" width=$width height=$height><BR>[$pic]</A>\n" if ($spec);
			print "<TD align=$second_table_align><A HREF=\"$url?action=view&offset=$offset&file=$j\"><IMG SRC=\"$pic\" width=$width height=$height><BR>[$pic]</A>\n" if (!($spec));
			next;
		}
		if (!(-e "$fs_thumbs_dir/$pic"))
		{
			my $image = new Image::Magick;
			$image->Read($pic);
			$image->Scale(geometry => $width."x".$height);
			$image->Write("$fs_thumbs_dir/$pic");
		}
		#print "<TD align=$second_table_align><A HREF=\"$url?action=view&offset=$offset&spec=$spec&file=$pic\"><IMG SRC=\"$httpd_thumbs_dir/$pic\"><BR>[$pic]</A></TD>\n" if ($spec);
		print "<TD align=$second_table_align><A HREF=\"$url?action=view&offset=$offset&spec=$spec&file=$j\"><IMG SRC=\"$httpd_thumbs_dir/$pic\"><BR>[$pic]</A></TD>\n" if ($spec);
		#print "<TD align=$second_table_align><A HREF=\"$url?action=view&offset=$offset&file=$pic\"><IMG SRC=\"$httpd_thumbs_dir/$pic\"><BR>[$pic]</A></TD>\n" if (!($spec));
		print "<TD align=$second_table_align><A HREF=\"$url?action=view&offset=$offset&file=$j\"><IMG SRC=\"$httpd_thumbs_dir/$pic\"><BR>[$pic]</A></TD>\n" if (!($spec));
	}

	print "</TR></TABLE>\n</TD></TR>\n<TR align=$first_table_align><TD>\n";
	print "<A HREF=\"http://rousse.pm.org/~georgi/webnailer/\" target=\"_blank\">Generated by webnailer v $version</A>\n";
	print "</TD></TR>\n";
	print "</TABLE></BODY></HTML>\n";
}
